<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */




/**
  @brief Call Specific Class provider for OScssShop Exts
  This class garanted process for dolibarr evolution
 */
// dol_include_once('/framework/core/lib/framework.lib.php');
//  
// newClass("OSEFacture");

namespace CORE;

dol_include_once('compta/facture/class/facture.class.php');

namespace CORE\FRAMEWORK;

use \CORE\FRAMEWORK\Facture as Facture;

namespace CORE\LCR;

use \CompanyBankAccount;

/**
  @brief Extends facture Class for add methode in facture
  @class FactureLcr
 */
class FactureLcr extends \Facture
{
    public $OSE_loaded_version = DOL_VERSION;

    /**
      @var int 0/1 option de pre-confirmation avant acceptation paiement lcr
     */
    public $preconfirm;

    /**
     */
    function fetch($id , $ref = '', $ref_ext = '', $ref_int = '', $fetch_situation = false)
    {
        $r = parent::fetch($id,$ref);

        if ($r <= 0) return $r;

        $sql = 'SELECT preconfirm, date_validation FROM '.MAIN_DB_PREFIX.'lcr_facture_preconfirm';
        $sql .= ' WHERE fk_facture = '.$this->id;

        $row = $this->db->query($sql);

        $obj = $this->db->fetch_object($row);

        $this->preconfirm = $obj->preconfirm;
        $this->preconfirm_date = $obj->date_validation;

        $sql2 = 'SELECT amount,date_demande,traite,date_traite,fk_lcr_bons, fk_user_demande,code_banque,code_guichet, number, cle_rib, date_lim_reglement FROM '.MAIN_DB_PREFIX.'lcr_facture_demande';
        $sql2 .= ' WHERE fk_facture = '.$this->id;
        $row2 = $this->db->query($sql2);

        $this->lcr_demande = array();
        while ($obj               = $this->db->fetch_object($row2)) {
            $this->lcr_demande[] = $obj;
        }


        return 1;
    }

    /**
     * 	Create a withdrawal request for a standing order
     *
     * 	@param      User	$user       User asking standing order
     *  @param		Montant
     *  @param 		Date
     *  @param 		mode 
     * 	@return     int         		<0 if KO, >0 if OK
     */
    function demande_lcr($user, $montant, $mode = '')
    {
        global $conf;
        dol_syslog(get_class($this)."::demande_lcr", LOG_DEBUG);

        if ($this->statut > 0 && $this->paye == 0) {
            require_once DOL_DOCUMENT_ROOT.'/societe/class/companybankaccount.class.php';
            $bac = new CompanyBankAccount($this->db);
            $bac->fetch(0, $this->socid);
            //echo $this->cond_reglement_code;
            //print_r($this);
            //$code_conditions_paiements=$this->get_code_conditions_paiements($this->fk_cond_reglement);
            $sql = 'SELECT count(*), SUM(amount) as amount ';
            $sql .= ' FROM '.MAIN_DB_PREFIX.'lcr_facture_demande';
            $sql .= ' WHERE fk_facture = '.$this->id;
            $sql .= " AND entity='".$conf->entity."'";
            $sql .= ' AND traite = 0';

            dol_syslog(get_class($this)."::demande_lcr sql=".$sql);
            $resql = $this->db->query($sql);
            if ($resql) {
                $row = $this->db->fetch_row($resql);
                if ($row[0] == 0 || $row[1] < $this->total_ttc) {
                    $now = dol_now();

//                     $totalpaye  = $this->getSommePaiement();
//                     $totalcreditnotes = $this->getSumCreditNotesUsed();
//                     $totaldeposits = $this->getSumDepositsUsed();
                    //print "totalpaye=".$totalpaye." totalcreditnotes=".$totalcreditnotes." totaldeposts=".$totaldeposits;
                    // We can also use bcadd to avoid pb with floating points
                    // For example print 239.2 - 229.3 - 9.9; does not return 0.
                    //$resteapayer=bcadd($this->total_ttc,$totalpaye,$conf->global->MAIN_MAX_DECIMALS_TOT);
                    //$resteapayer=bcadd($resteapayer,$totalavoir,$conf->global->MAIN_MAX_DECIMALS_TOT);
//                     $resteapayer = price2num($this->total_ttc - $totalpaye - $totalcreditnotes - $totaldeposits,'MT');

                    $resteapayer = $montant;

                    //	echo $this->cond_reglement_code."=='3060JOURS'&round($resteapayer,2)==round(".$this->total_ttc.",2)";exit;
                    if ($this->cond_reglement_code == '3060JOURS' & round($resteapayer, 2) == round($this->total_ttc, 2)) {
                        $sql          = 'INSERT INTO '.MAIN_DB_PREFIX.'lcr_facture_demande';
                        $sql          .= ' (fk_facture,entity, amount, date_demande, fk_user_demande, code_banque, code_guichet, number, cle_rib,date_lim_reglement, mode)';
                        $sql          .= ' VALUES ('.$this->id;
                        $resteapayer1 = round($resteapayer / 2, 2);
                        $resteapayer  = round($resteapayer, 2) - $resteapayer1;
                        $sql          .= ",'".$conf->entity."'";
                        $sql          .= ",'".price2num($resteapayer1)."'";
                        $sql          .= ",'".$this->db->idate($now)."'";
                        $sql          .= ",".$user->id;
                        $sql          .= ",'".$bac->code_banque."'";
                        $sql          .= ",'".$bac->code_guichet."'";
                        $sql          .= ",'".$bac->number."'";
                        $sql          .= ",'".$bac->cle_rib."'";
                        //$sql .= ",'".str_replace('01-27 ','01-30 ',str_replace('01-28 ','01-30 ',str_replace('01-29 ','01-30 ',str_replace('-31 ','-30 ',str_replace('-14 ','-15 ',str_replace('-16 ','-15 ',date('Y-m-d H:i:s',strtotime('-30day',$this->date_lim_reglement))))))))."'";

                        $sql .= ",'".date('Y-m-d H:i:s',
                                ((date('n', $this->date_lim_reglement) * 1 == 2 & date('t', $this->date_lim_reglement) * 1
                                == date('j', $this->date_lim_reglement) * 1) ? strtotime("-".(date('t',
                                        $this->date_lim_reglement) + 1)."day", $this->date_lim_reglement) :
                                ((date('n', $this->date_lim_reglement) * 1 == 3 & date('t',
                                    strtotime("-31day", $this->date_lim_reglement)) * 1 < date('j',
                                    $this->date_lim_reglement) * 1) ? strtotime("-".(date('j', $this->date_lim_reglement))."day",
                                    $this->date_lim_reglement) : strtotime("-1month", $this->date_lim_reglement))))."'";
                        $sql .= ", '".(($mode > 0) ? "1" : "0")."')";
                        dol_syslog(get_class($this)."::demande_lcr sql=".$sql);
                        if ($this->db->query($sql)) {
                            //	return 1;
                        } else {
                            $this->error = $this->db->lasterror();
                            dol_syslog(get_class($this).'::demandelcr Erreur');
                            return -1;
                        }
                        $sql = 'INSERT INTO '.MAIN_DB_PREFIX.'lcr_facture_demande';
                        $sql .= ' (fk_facture, entity, amount, date_demande, fk_user_demande, code_banque, code_guichet, number, cle_rib,date_lim_reglement, mode)';
                        $sql .= ' VALUES ('.$this->id;
                        $sql .= ",'".$conf->entity."'";
                        $sql .= ",'".price2num($resteapayer)."'";
                        $sql .= ",'".$this->db->idate($now)."'";
                        $sql .= ",".$user->id;
                        $sql .= ",'".$bac->code_banque."'";
                        $sql .= ",'".$bac->code_guichet."'";
                        $sql .= ",'".$bac->number."'";
                        $sql .= ",'".$bac->cle_rib."','".date('Y-m-d H:i:s', $this->date_lim_reglement)."', '".(($mode > 0)
                                ? "1" : "0")."')";
                        dol_syslog(get_class($this)."::demande_lcr sql=".$sql);
                        if ($this->db->query($sql)) {
                            //return 1;
                        } else {
                            $this->error = $this->db->lasterror();
                            dol_syslog(get_class($this).'::demandelcr Erreur');
                            return -1;
                        }
                    } else {
                        $sql = 'INSERT INTO '.MAIN_DB_PREFIX.'lcr_facture_demande';
                        $sql .= ' (fk_facture,entity, amount, date_demande, fk_user_demande, code_banque, code_guichet, number, cle_rib,date_lim_reglement, mode)';
                        $sql .= ' VALUES ('.$this->id;
                        $sql .= ",'".$conf->entity."'";
                        $sql .= ",'".price2num($resteapayer)."'";
                        $sql .= ",'".$this->db->idate($now)."'";
                        $sql .= ",".$user->id;
                        $sql .= ",'".$bac->code_banque."'";
                        $sql .= ",'".$bac->code_guichet."'";
                        $sql .= ",'".$bac->number."'";
                        $sql .= ",'".$bac->cle_rib."','".date('Y-m-d H:i:s', $this->date_lim_reglement)."', '".(($mode > 0)
                                ? "1" : "0")."')";


                        dol_syslog(get_class($this)."::demande_lcr sql=".$sql);
                        if ($this->db->query($sql)) {
                            return 1;
                        } else {
                            $this->error = $this->db->lasterror();
                            dol_syslog(get_class($this).'::demandelcr Erreur');
                            return -1;
                        }
                    }
                } else {
                    $this->error = "A request already exists";
                    dol_syslog(get_class($this).'::demandelcr Impossible de creer une demande, demande deja en cours');
                }
            } else {
                $this->error = $this->db->error();
                dol_syslog(get_class($this).'::demandelcr Erreur -2');
                return -2;
            }
        } else {
            $this->error = "Status of invoice does not allow this";
            dol_syslog(get_class($this)."::demandelcr ".$this->error." $this->statut, $this->paye, $this->mode_reglement_id");
            return -3;
        }
    }

    /**
     *  Supprime une demande de lcr
     *
     *  @param  Use		$user       utilisateur creant la demande
     *  @param  int		$did        id de la demande a supprimer
     *  @return	int					<0 if OK, >0 if KO
     */
    function demande_lcr_delete($user, $did)
    {
        $sql = 'DELETE FROM '.MAIN_DB_PREFIX.'lcr_facture_demande';
        $sql .= ' WHERE rowid = '.$did;
        $sql .= ' AND traite = 0';
        if ($this->db->query($sql)) {
            return 0;
        } else {
            $this->error = $this->db->lasterror();
            dol_syslog(get_class($this).'::demande_lcr_delete Error '.$this->error);
            return -1;
        }
    }

    /**
      @fn preconfirm_confirm($preconfirm)
     */
    function preconfirm_confirm($preconfirm, $preconfirmdate=false)
    {
        global $conf;
        if($preconfirmdate === false|| $preconfirmdate == ""){
            $preconfirmdate = date('Y-m-d 00:00:00');
        } else {
            $d = explode('/',$preconfirmdate);
            $preconfirmdate = "{$d[2]}-{$d[1]}-{$d[0]} 00:00:00";
        }
        $sql = 'INSERT INTO '.MAIN_DB_PREFIX.'lcr_facture_preconfirm';
        $sql .= ' (fk_facture ,entity, preconfirm, date_validation)  ';
        $sql .= " VALUES ('{$this->id}', '{$conf->entity}', '{$preconfirm}','$preconfirmdate')";



        if ($this->db->query($sql)) {
            return 0;
        } else {
            $this->error = $this->db->lasterror();
            dol_syslog(get_class($this).'::preconfirm_confirm Error '.$this->error);
            return -1;
        }
    }
}
?>
