<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace CORE;
/**
 * 	\file       lcr/core/boxes/box_lcr_last.php
 * 	\ingroup    lcr
 * 	\brief      Module to build boxe for events
 */
include_once DOL_DOCUMENT_ROOT . '/core/boxes/modules_boxes.php';

namespace CORE\LCR;
/**
 * Class to manage the box to show last events
 */
class box_lcr_last extends \ModeleBoxes {

    var $boxcode = "lcr_last";
    var $boximg = "object_lcr";
    var $boxlabel = "Box_lcr_last";
    var $depends = array();
    var $db;
    var $param;
    var $info_box_head = array();
    var $info_box_contents = array();
    var $source;

    public  $enabled = true

	, $defaulton =  array(
					'lcr'
				) ; 
								
    public function __construct($db, $param = '') {
				 global $user, $langs,  $conf, $bc;
				 
        //init
        $this->db = $db;
        $this->param = $param;
        parent::__construct($db, $param);
        
        if (empty($conf->lcr->enabled))
					$this->enabled = false;
    }

    /**
     *  Load data for box to show them later
     *
     *  @param	int		$max        Maximum number of records to load
     *  @return	void
     */
    function loadBox($max = 5) {
        global $user, $langs,  $conf;

        dol_include_once('/lcr/class/bonlcr.class.php');
		dol_include_once('/lcr/core/lib/lcr.lib.php');

		$db = $this->db; 

        $bprev = new BonLcr($db);
// 		$limit=5;
		$sql = "SELECT p.rowid, p.ref, p.amount, p.datec, p.statut";
		$sql.= " FROM ".MAIN_DB_PREFIX."lcr_bons as p";
		$sql.= " ORDER BY datec DESC";
		$sql.= $db->plimit($max);

		$result = $db->query($sql);
		if ($result)
		{
			$num = $db->num_rows($result);
			$i = 0;
			$var=True;

					$output.='<table class="noborder" width="100%">';
// 		$output.='<tr>';
// 			$output .="\n<!-- debut table -->\n";
			$output .= '<table class="noborder" width="100%">';
// 			$output .= '<tr ><td>'.$langs->trans("LastWithdrawalReceipt",$limit).'</td>';
// 			$output .= '<td>'.$langs->trans("Date").'</td>';
// 			$output .= '<td align="right">'.$langs->trans("Amount").'</td>';
// 			$output .= '<td align="right">'.$langs->trans("Status").'</td>';
// 			$output .= '</tr>';

			while ($i < min($num,$max))
			{
				$obj = $db->fetch_object($result);
				$var=!$var;

						$bprev->id=$obj->rowid;
				$bprev->ref=$obj->ref;
				$bprev->statut=$obj->statut;
				
				$output .= "<tr ".$bc[$var].">";

				$output .= "<td>"
									. $bprev->getNomUrl(1)
									. "</td>\n";
				$output .= '<td>'.dol_print_date($db->jdate($obj->datec),"dayhour")."</td>\n";
				$output .= '<td align="right">'.price($obj->amount)."</td>\n";
				$output .= '<td align="right">'.$bprev->getLibStatut(3)."</td>\n";

				$output .= "</tr>\n";
				$i++;
			}
			$output .= "</table>";
			$db->free($result);
		}
		else
		{
			dol_print_error($db);
		}

  
			$this->info_box_contents[0][0] = array(
							'td' => 'align="center" class="nohover"'
						, 'textnoformat' => $output
						);
            
        $this->info_box_head = array(
            'text' => $langs->trans("LastWithdrawalReceipt",$max).'<a href="'.dol_buildPath('/lcr/list.php',2).'"></a>',
//             'limit' => dol_strlen($langs->trans("OrdersToProcess")),
            'graph' => 0,
            'target' => 'none'
        );

    }
    
    

    

    /**
     * 	Method to show box
     *
     * 	@param	array	$head       Array with properties of box title
     * 	@param  array	$contents   Array with properties of box lines
     * 	@return	void
     */
    function showBox($head = null, $contents = null, $nooutput=0) {
        parent::showBox($this->info_box_head, $this->info_box_contents);
    }

}
