<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace CORE;
/**
 * 	\file       lcr/core/boxes/box_lcr_stats.php
 * 	\ingroup    lcr
 * 	\brief      Module to build boxe for events
 */
include_once DOL_DOCUMENT_ROOT . '/core/boxes/modules_boxes.php';

namespace CORE\LCR;
/**
 * Class to manage the box to show last events
 */
class box_lcr_stats extends \ModeleBoxes {

    var $boxcode = "lcr_stats";
    var $boximg = "object_lcr";
    var $boxlabel = "Box_lcr_stats";
    var $depends = array();
    var $db;
    var $param;
    var $info_box_head = array();
    var $info_box_contents = array();
    var $source;

    public  $enabled = true

	, $defaulton =  array(
					'lcr'
				) ; 
								
    public function __construct($db, $param = '') {
				 global $user, $langs,  $conf, $bc;
				 
        //init
        $this->db = $db;
        $this->param = $param;
        parent::__construct($db, $param);
        
        if (empty($conf->lcr->enabled))
					$this->enabled = false;
    }

    /**
     *  Load data for box to show them later
     *
     *  @param	int		$max        Maximum number of records to load
     *  @return	void
     */
    function loadBox($max = 5) {
        global $user, $langs,  $conf;

// 		dol_include_once('/lcr/class/lignelcr.class.php');
// 		dol_include_once('/lcr/class/rejetlcr.class.php');
// 		dol_include_once('/lcr/class/facture.lcr.class.php');
		dol_include_once('/lcr/class/bonlcr.class.php');
// 		dol_include_once('/lcr/core/lib/lcr.lib.php');

		$db = $this->db; 

// 		$thirdpartystatic=new Societe($db);
// 		$invoicestatic=new FactureLcr($db);
		$bprev = new BonLcr($db);
		$var=true;

		$output .= '<table class="noborder" width="100%">';
// 		$output .= '<tr class="liste_titre"><td colspan="2">'.$langs->trans("Statistics").'</td></tr>';
		$var=!$var;
		$output .= '<tr '.$bc[$var].'><td>'.$langs->trans("NbOfInvoiceToWithdraw").'</td>';
		$output .= '<td align="right">';
		$output .= '<a href="'.dol_buildpath('/lcr/demandes.php?status=0',1).'">';
		$output .= $bprev->NbFactureAPrelever();
		$output .= '</a>';
		$output .= '</td></tr>';
		$var=!$var;
		$output .= '<tr '.$bc[$var].'><td>'.$langs->trans("AmountToWithdraw").'</td>';
		$output .= '<td align="right">';
		$output .= price($bprev->SommeAPrelever(),'','',1,-1,-1,$conf->currency);
		$output .= '</td></tr>';
		$output.='</table>'; 
  
		$this->info_box_contents[0][0] = array(
						'td' => 'align="center" class="nohover"'
					, 'textnoformat' => $output
					);
            
        $this->info_box_head = array(
            'text' => $langs->trans("Statistics"),
            'limit' => dol_strlen($langs->trans("OrdersToProcess")),
            'graph' => 0,
            'target' => 'none'
        );

    }
    
    

    

    /**
     * 	Method to show box
     *
     * 	@param	array	$head       Array with properties of box title
     * 	@param  array	$contents   Array with properties of box lines
     * 	@return	void
     */
    function showBox($head = null, $contents = null, $nooutput=0) {
        parent::showBox($this->info_box_head, $this->info_box_contents);
    }

}
