<?PHP
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
        \file       htdocs/compta/lcr/liste_factures.php
        \ingroup    lcr
        \brief      Page liste des factures pr�lev�es
        \version    $Id: liste_factures.php,v 1.11 2009/02/20 22:53:46 eldy Exp $
*/
namespace CORE;



$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");
    
    
    
/**
	@brief Call Specific Class provider for OScssShop Exts 
		This class garanted process for dolibarr evolution 
*/
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');
    
    
loadClass("Societe");
loadClass("User");

    
namespace CORE\FRAMEWORK;

namespace CORE\LCR;

use \CORE\LCR\FactureLcr;
use \CORE\LCR\BonLcr;
use \CORE\LCR\LigneLcr;
use \CORE\FRAMEWORK\Societe;

dol_include_once('/lcr/class/facture.lcr.class.php');
dol_include_once('/lcr/class/bonlcr.class.php');
dol_include_once('/lcr/class/lignelcr.class.php');
dol_include_once('/lcr/class/rejetlcr.class.php');



require_once(DOL_DOCUMENT_ROOT."/compta/paiement/class/paiement.class.php");

// S�curit� acc�s client
if ($user->societe_id > 0) 
	accessforbidden();

$langs->load("companies");
$langs->load("lcr@lcr");



$StaticBon=new BonLcr($db,"");
$StaticLigne = new LigneLcr($db, $user);
$StaticFactureLcr =new FactureLcr($db);
$StaticSociete =new Societe($db);


$ligne=new LigneLcr($db,$user);
$bon=new BonLcr($db,$user);

/*
 * View
 */

llxHeader('',$langs->trans("WithdrawedBills"));

$page = $_GET["page"];
$sortorder = (empty($_GET["sortorder"])) ? "DESC" : $_GET["sortorder"];
$sortfield = (empty($_GET["sortfield"])) ? "p.datec" : $_GET["sortfield"];
$offset = $conf->liste_limit * $page ;

/*
 * Liste des factures
 *
 *
 */
$sql = "SELECT p.rowid, p.ref, p.statut";
$sql .= " ,f.rowid as facid, f.ref as facnumber, f.total_ttc";
$sql .= " , s.rowid as socid, s.nom";
$sql .= " , pl.statut as statut_ligne, pl.rowid as rowid_ligne";
$sql .= " FROM ".MAIN_DB_PREFIX."lcr_bons as p";
$sql .= " , ".MAIN_DB_PREFIX."lcr_lignes as pl";
$sql .= " , ".MAIN_DB_PREFIX."lcr_facture as pf";
$sql .= " , ".MAIN_DB_PREFIX."facture as f";
$sql .= " , ".MAIN_DB_PREFIX."societe as s";
$sql .= " WHERE pf.fk_lcr_lignes = pl.rowid";
$sql .= " AND pl.fk_lcr_bons = p.rowid";
$sql .= " AND f.fk_soc = s.rowid";
$sql .= " AND pf.fk_facture = f.rowid";

if ($_GET["socid"])
{
  $sql .= " AND s.rowid = ".$_GET["socid"];
}

if ($_GET["search_fac"])
{
  $sql .= " AND f.ref like '%".$_GET["search_fac"]."%'";
}

if ($_GET["search_nom"])
{
  $sql .= " AND s.nom like '%".$_GET["search_nom"]."%'";
}

$sql .= " ORDER BY $sortfield $sortorder " . $db->plimit($conf->liste_limit+1, $offset);

$result = $db->query($sql);




if ($result)
{
  $num = $db->num_rows($result);
  $i = 0;
  
  $urladd = "&amp;socid=".$_GET["socid"];

  print_barre_liste($langs->trans("WithdrawedBills"), $page, "liste_factures.php", $urladd, $sortfield, $sortorder, '', $num);

  print"\n<!-- debut table -->\n";
  print '<table class="liste" width="100%">';
  print '<tr class="liste_titre">';
  print '<td class="liste_titre">'.$langs->trans("Line").'</td>';
  print_liste_field_titre($langs->trans("Bill"),"liste_factures.php","f.facnumber",'',$urladd);
  print_liste_field_titre($langs->trans("Company"),"liste_factures.php","s.nom",'',$urladd);
  print_liste_field_titre($langs->trans("Amount"),"liste_factures.php","f.total_ttc","",$urladd,'align="right"');
  print_liste_field_titre($langs->trans("WithdrawalReceipt"),"liste_factures.php","p.rowid","",$urladd,'align="center"');
  print '</tr>';

  print '<form method="get" action="liste_factures.php">';
  print '<tr class="liste_titre"><td class="liste_titre">&nbsp;</td>';
  print '<td class="liste_titre">';
  print '<input size="8" class="flat" type="text" name="search_fac" value="'.$_GET["search_fac"].'">';
  print '</td><td class="liste_titre">';
  print '<input size="20" class="flat" type="text" name="search_nom" value="'.$_GET["search_nom"].'">';
  print '</td>';
  print '<td class="liste_titre" colspan="2" align="right"><input type="image" class="liste_titre" src="'.DOL_URL_ROOT.'/theme/'.$conf->theme.'/img/search.png" name="button_search" alt="'.$langs->trans("Search").'"></td>';
  print "</tr>\n";
  print '</form>';

  $var=false;

  $total = 0;

  while ($i < min($num,$conf->liste_limit))
    {
      $obj = $db->fetch_object($result);	
        
				$StaticLigne->id = $obj->rowid_ligne;
				$StaticLigne->statut = $obj->statut_ligne;
				$StaticLigne->ref = substr('000000'.$obj->rowid_ligne, -6);
				
				$StaticBon->id = $obj->rowid ; 
				$StaticBon->statut = $obj->statut;
				$StaticBon->ref = $obj->ref ; 
				
				$StaticFactureLcr->id = $obj->facid ; 
				$StaticFactureLcr->statut = $obj->facstatus;
				$StaticFactureLcr->ref = $obj->facnumber ; 

				$StaticSociete->id = $obj->socid; 
				$StaticSociete->nom = $obj->nom; 
				
				
				 print "<tr $bc[$var]>";
				
				print '<td>'
							.$StaticLigne->getNomUrl(1,16)
							.'</td>';
					

			print '<td>'
						.$StaticFactureLcr->getNomUrl(1,16)
						.'</td>';
							
							
				print '<td>'
							.$StaticSociete->getNomUrl(1,16)
							.'</td>';

							


      print '<td align="right">'.price($obj->total_ttc)."</td>\n";


				print '<td align="center">'
							.$StaticBon->getNomUrl(1,16)
							.'</td>';
							
							
      print '</tr>';

      $total += $obj->total_ttc;
      $var=!$var;
      $i++;
    }

  print "</table>";
  $db->free($result);
}
else 
{
  dol_print_error($db);
}

$db->close();

llxFooter('$Date: 2009/02/20 22:53:46 $ - $Revision: 1.11 $');
?>
