<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *     \file       htdocs/compta/lcr/factures.php
 *     \ingroup    lcr
 *     \brief      Page liste des factures prelevees
 */
namespace CORE;

$res = 0;
// if (!$res && file_exists("../main.inc.php"))
//     $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");

    

require_once DOL_DOCUMENT_ROOT.'/compta/paiement/class/paiement.class.php';
require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';


/**
	@brief Call Specific Class provider for OScssShop Exts 
		This class garanted process for dolibarr evolution 
*/
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');
    
    
namespace CORE\FRAMEWORK;

namespace CORE\LCR;

use \CORE\LCR\FactureLcr;
use \CORE\LCR\LigneLcr;

use \User;

use \CORE\FRAMEWORK\Societe;

dol_include_once('/lcr/class/bonlcr.class.php');
dol_include_once('/lcr/class/facture.lcr.class.php');
dol_include_once('/lcr/class/rejetlcr.class.php');
dol_include_once('/lcr/class/lignelcr.class.php');


dol_include_once('/lcr/core/lib/lcr.lib.php');

loadClass("Societe");
loadClass("User");



$langs->load("banks");
$langs->load("categories");
$langs->load("companies");
$langs->load('withdrawals');
$langs->load('bills');

// Securite acces client
if ($user->societe_id > 0) accessforbidden();

// Get supervariables
$prev_id = GETPOST('id','int');
$socid = GETPOST('socid','int');
$page = GETPOST('page','int');
$sortorder = ((GETPOST('sortorder','alpha')=="")) ? "DESC" : GETPOST('sortorder','alpha');
$sortfield = ((GETPOST('sortfield','alpha')=="")) ? "p.ref" : GETPOST('sortfield','alpha');





// $StaticBon=new BonLcr($db,"");
$StaticLigne = new LigneLcr($db, $user);
$StaticFactureLcr =new FactureLcr($db);
$StaticSociete =new Societe($db);



llxHeader('',$langs->trans("WithdrawalReceipts"));

if ($prev_id)
{
  	$bon = new BonLcr($db,"");
  	
		print PrintHeadCardTab('invoices', $bon, $prev_id); 


}

$offset = $conf->liste_limit * $page ;

/*
 * Liste des factures
 */
$sql = "SELECT pf.rowid";
$sql.= ",f.rowid as facid, f.ref as ref, f.total_ttc";
$sql.= ", s.rowid as socid, s.nom, pl.statut,pl.amount";
$sql.= " FROM ".MAIN_DB_PREFIX."lcr_bons as p";
$sql.= ", ".MAIN_DB_PREFIX."lcr_lignes as pl";
$sql.= ", ".MAIN_DB_PREFIX."lcr_facture as pf";
$sql.= ", ".MAIN_DB_PREFIX."facture as f";
$sql.= ", ".MAIN_DB_PREFIX."societe as s";
$sql.= " WHERE pf.fk_lcr_lignes = pl.rowid";
$sql.= " AND pl.fk_lcr_bons = p.rowid";
$sql.= " AND f.fk_soc = s.rowid";
$sql.= " AND pf.fk_facture = f.rowid";
$sql.= " AND f.entity = ".$conf->entity;
$sql.= " AND p.rowid = '".$prev_id."'";
$sql.= " ORDER BY $sortfield $sortorder ";
$sql.= $db->plimit($conf->liste_limit+1, $offset);

$result = $db->query($sql);

if ($result)
{
  	$num = $db->num_rows($result);
  	$i = 0;

  	$urladd = "&amp;id=".$prev_id;

  	print_barre_liste("", $page, "factures.php", $urladd, $sortfield, $sortorder, '', $num);

  	print"\n<!-- debut table -->\n";
  	print '<table class="liste" width="100%">';
  	print '<tr class="liste_titre">';
  	print_liste_field_titre($langs->trans("Bill"),"factures.php","p.ref",'',$urladd,'class="liste_titre"',$sortfield,$sortorder);
  	print_liste_field_titre($langs->trans("ThirdParty"),"factures.php","s.nom",'',$urladd,'class="liste_titre"',$sortfield,$sortorder);
	print_liste_field_titre($langs->trans("Amount"),"factures.php","p.amount","",$urladd,'class="liste_titre" align="center"',$sortfield,$sortorder);
  	print_liste_field_titre($langs->trans("TotalTTC"),"factures.php","f.total_ttc","",$urladd,'class="liste_titre" align="center"',$sortfield,$sortorder);
  	print '<td class="liste_titre" colspan="2">&nbsp;</td></tr>';

  	$var=false;

  	$total = 0;

  	while ($i < min($num,$conf->liste_limit))
    {
     	$obj = $db->fetch_object($result);

     	$StaticFactureLcr->id = $obj->facid; 
     	$StaticFactureLcr->ref = $obj->ref; 
     	
     	$StaticSociete->id = $obj->socid; 
     	$StaticSociete->nom = $obj->nom; 
     	

			print '<tr '.$bc[$var].'>';

			print '<td>'
						.$StaticFactureLcr->getNomUrl(1,'withdrawlcr')
						. '</td>';
			print '<td>'
						.$StaticSociete->getNomUrl(1,'customer')
						. '</td>';
									

			print '<td align="center">'.price($obj->amount)."</td>\n";
			print '<td align="center"> '.price($obj->total_ttc)."</td>\n";

			print '<td>';

      	
			print '<td>'
						.$StaticLigne->LibStatut($obj->statut,1)
						. '</td>';


      	print "</tr>\n";

      	$total += $obj->total_ttc;
      	$var=!$var;
      	$i++;
    }


  	print "</table>";
  	$db->free($result);
}
else
{
	dol_print_error($db);
}

$db->close();

llxFooter();
